uniform sampler2D tex;
uniform float width;
uniform float height;

varying vec2 v_texCoords;

float r = 3.;
float sn = .06;

void main()
{
  vec2 resolution = vec2(width, height);
  vec4 col = vec4(0., 0., 0., 0.);
  float d = 1.;
  for (float i = -r; i <= r; i++) {
    for (float j = -r; j <= r; j++) {
      vec2 sh = vec2(i, j) / resolution.xy;
      if(i == 0. && j == 0.) d = .9;
      else d = sn / (i*i + j*j);
      col += texture2D(tex, v_texCoords.xy + sh) * d;
    }
  }
  gl_FragColor = vec4(col.xyz, texture2D(tex, v_texCoords.xy).w);
}